;--- http://radiohlam.ru ---
.device ATtiny2313
.include "tn2313def.inc"
.list
;--   
.def	 Speed=r0		   ;      (       )
.def	 NewSpeed=r1	   ;    (  ,      )
.def	 Acceleration=r2   ;  ,     ()

.def     w0=r16            ;    
.def     w1=r17            ;    
.def     CurrentState0=r18 ;     0
.def     CurrentStateX=r19 ; ,    
.def     CurrentState1=r20 ;     1
.def     StepCounter=r21   ;   
.def     SpeedCounter=r22  ;       
.def     AccelerationCounter=r23  ;        
.def	 Flags=r24		   ;   
.def     UartData=r25      ;     UART

;--   (   )
;--- 
.equ	Command1 = 0x06		;	  
.equ	Command2 = 0x05		;	   
.equ	Command3 = 0x07		;	  
.equ	Command4 = 0x01		;	
.equ	Command5 = 0x02		;	
.equ	Command6 = 0x03		;	
.equ	Command7 = 0x04		;	
;--- 
.equ	Wait = 0x00			;	 
.equ	Good = 0x01			;	 
.equ	Error = 0xFE		;	  
;---    
.equ	MaxShim = 212		;	  (256-44; 84,8 )
.equ	MinShim = 12		;	   (4,8 )
;---  
.equ	StartShim = 16		;	.. 32/256=0,125; U=0,75
.equ	StartSpeed = 255	;	1/(255*102,4*6*N)=6,4/N ; (N-  ,  3    127 /) (0x0C=12  - 2700 /, 5 - 6500 /, 3 - 10850 /, 1 - 32550 /)
.equ	StartAcc = 9		;      1   9 
.equ	FreeTime = 32       ;	     ;  T=102,4   256  (12,8 )
;----------------------------------------------------------
;--     
.equ     State00=0b00010100 ; U=0, V=0,W=Z     U
.equ     State0x=0b00010000 ; U=Z, V=0,W=Z  0   V
.equ     State01=0b00011000 ; U=1, V=0,W=Z  Z   W

.equ     State10=0b01000100 ; U=0, V=Z,W=0     U
.equ     State1x=0b01000000 ; U=Z, V=Z,W=0  Z   V
.equ     State11=0b01001000 ; U=1, V=Z,W=0  0   W

.equ     State20=0b01010000 ; U=Z, V=0,W=0  Z   U
.equ     State2x=0b01000000 ; U=Z, V=Z,W=0     V
.equ     State21=0b01100000 ; U=Z, V=1,W=0  0   W

.equ     State30=0b00010100 ; U=0, V=0,W=Z  0   U
.equ     State3x=0b00000100 ; U=0, V=Z,W=Z     V
.equ     State31=0b00100100 ; U=0, V=1,W=Z  Z   W

.equ     State40=0b01000100 ; U=0, V=Z,W=0  0   U
.equ     State4x=0b00000100 ; U=0, V=Z,W=Z  Z   V
.equ     State41=0b10000100 ; U=0, V=Z,W=1     W

.equ     State50=0b01010000 ; U=Z, V=0,W=0  Z   U
.equ     State5x=0b00010000 ; U=Z, V=0,W=Z  0   V
.equ     State51=0b10010000 ; U=Z, V=0,W=1     W
;-- 
.equ     SpeedFlag=0			; , ,    
.equ     NeedReadSpeed=1		; , ,       ( )
.equ     NeedReadShim=2			; , ,         ( )
.equ	 NeedReadAcceleration=3	; , ,      
.equ	 StartFlag=4			; , ,    
.equ	 ReverseFlag=5			; , ,     
;----------------------------
;--   
        .cseg
        .org 0
        rjmp Init        ;     ( )
;--    
;--    -  reti,  -    
    reti         ;   INT0
	reti         ;   INT1
	reti         ; Input capture interrupt 1
	reti		 ; Timer/Counter1 Compare Match A
	reti         ; Overflow1 Interrupt
	rjmp TMR0_OVF; Overflow0 Interrupt
	reti		 ; USART0 RX Complete Interrupt
	reti         ; USART0 Data Register Empty Interrupt
	reti         ; USART0 TX Complete Interrupt
	reti         ; Analog Comparator Interrupt
	reti         ; Pin Change Interrupt
	reti         ; Timer/Counter1 Compare Match B
	rjmp TMR0_CMA; Timer/Counter0 Compare Match A
	rjmp TMR0_CMB; Timer/Counter0 Compare Match B
	reti         ; USI start interrupt
	reti         ; USI overflow interrupt
	reti         ; EEPROM write complete
	reti         ; Watchdog Timer Interrupt
;--  
Init:   ldi w0,RAMEND    ;   
        out SPL,w0       ;     RAM
        sbi ACSR,ACD     ;  
	;--  
        ser w0           ; w0=0xFF
		clr w1           ; w1=0x00
        out DDRA,w0      ;   A.    
		out DDRB,w0      ;   B.    
        out DDRD,w0      ;   D.    		
		out PORTA,w1     ;    
		out PORTB,w1     ;    
        out PORTD,w1     ;    
	;--  UART
		out UBRRH,w1     ; UBRR (  20    115200)
		ldi w0,10        ;  10, .. UBRRH=0, UBRRL=10
		out UBRRL,w0
		ldi w0,0b00001110 ;   USBS, UCSZ1:0
		out UCSRC,w0     ; : 1 , 8 , 2 
		sbi UCSRB, TXEN  ;  
		nop
		sbi UCSRB, RXEN  ;  
    ;--   0 (   )
        out TCCR0A,w1    ;     OC0A(B)
        out TCNT0,w1     ;  
    	ldi w0,StartShim ;    
		out OCR0A,w0
		ldi w0,256-FreeTime	 ;    32*T/256      
		out OCR0B,w0
	;--    
		ldi w0,0b00000111
        out TIMSK,w0     ;     TMR0, OCF0A, OCF0B
        ser w0
        out TIFR,w0      ;   
	;--    
		ldi CurrentState0,State00 ; 
		ldi CurrentStateX,State0x ; Z
		ldi CurrentState1,State01 ; 
		clr StepCounter
		clr SpeedCounter
		clr	AccelerationCounter
		clr Flags
		ldi	w0,StartSpeed	   ;   
		mov Speed,w0
		mov NewSpeed,Speed
		ldi	w0,StartAcc
		mov Acceleration,w0    ;     ()
	;--   0
		ldi w0,0b00000010   ;   8,    =102,4 , =0,4 ,  9,8 
		out TCCR0B,w0       ;   0
	;--   
		out		PORTB,CurrentState0 ;   0
        sei
    ;--     ---
Wait_data:
		rjmp Wait_data
;************************************************
;***  *********************************
;--     TMR0 c OCR0A
TMR0_CMA:	out		PORTB,CurrentStateX ; 
			rcall	Pause
			sbrc	Flags,StartFlag		;  StartFlag  - 
			out		PORTB,CurrentState0 ;   0
			reti
;--     TMR0
TMR0_OVF:   out		PORTB,CurrentStateX ; 
			rcall	Pause
			sbrc	Flags,StartFlag		;  StartFlag  - 
			out		PORTB,CurrentState1 ;   1
			inc		SpeedCounter
			reti
;--     TMR0 c OCR0B
TMR0_CMB: ;---    
			cp		SpeedCounter,Speed  ;    -  
			brne	NoChangeStep
			rcall	StepChange
NoChangeStep:
		  ;---    
			cp		AccelerationCounter,Acceleration ;    -  
			brne	NoChangeSpeed
		  	sbrc	Flags,SpeedFlag		;    -    
			rcall	NeedChangeSpeed
			clr		AccelerationCounter
NoChangeSpeed:
		  ;---     UART
		  	sbic	UCSRA, RXC	;    -   
			rcall	RecieveData
			reti
;************************************************
;***  ************************************
;------------------------------------------------
;---  (1,6 ) ----------------------------
Pause:	ldi		w1,8
WaitPause:
		dec		w1
		brne	WaitPause
		ret
;------------------------------------------------
;-      (1,7 )
StepChange: clr 	SpeedCounter
			inc		AccelerationCounter
			inc		StepCounter		;  
			cpi		StepCounter,6	;   (   )
			brne	TestReverse
			clr		StepCounter		;  
TestReverse:
			sbrc	Flags,ReverseFlag	;  ReverseFlag  -  
			rjmp	GetReverseAddress
	;---     
GetForwardAddress:
			rcall	StartForwardCase
StartForwardCase:
			pop		ZH
			pop		ZL
			adiw	ZL,7
			add		ZL,StepCounter
			brcc	FNotC
			inc		ZH
FNotC:	ijmp
		rjmp	FOp0
		rjmp	FOp1
		rjmp	FOp2
		rjmp	FOp3
		rjmp	FOp4
		rjmp	FOp5
	;---    U
FOp0:	ldi		CurrentState0,State00
		ldi		CurrentStateX,State0x
		ldi		CurrentState1,State01
		rjmp	ExitChange
FOp1:	ldi		CurrentState0,State10
		ldi		CurrentStateX,State1x
		ldi		CurrentState1,State11
		rjmp	ExitChange
	;---    V
FOp2:	ldi		CurrentState0,State20
		ldi		CurrentStateX,State2x
		ldi		CurrentState1,State21
		rjmp	ExitChange
FOp3:	ldi		CurrentState0,State30
		ldi		CurrentStateX,State3x
		ldi		CurrentState1,State31
		rjmp	ExitChange
	;---    W
FOp4:	ldi		CurrentState0,State40
		ldi		CurrentStateX,State4x
		ldi		CurrentState1,State41
		rjmp	ExitChange
FOp5:	ldi		CurrentState0,State50
		ldi		CurrentStateX,State5x
		ldi		CurrentState1,State51
		rjmp	ExitChange
ExitChange:
		ret
	;---     
GetReverseAddress:
			rcall	StartReverseCase
StartReverseCase:
			pop		ZH
			pop		ZL
			adiw	ZL,7
			add		ZL,StepCounter
			brcc	RNotC
			inc		ZH
RNotC:	ijmp
		rjmp	ROp0
		rjmp	ROp1
		rjmp	ROp2
		rjmp	ROp3
		rjmp	ROp4
		rjmp	ROp5
	;---    U
ROp0:	ldi		CurrentState0,State10
		ldi		CurrentStateX,State1x
		ldi		CurrentState1,State11
		rjmp	ExitChange
ROp1:	ldi		CurrentState0,State00
		ldi		CurrentStateX,State0x
		ldi		CurrentState1,State01
		rjmp	ExitChange
	;---    W
ROp2:	ldi		CurrentState0,State50
		ldi		CurrentStateX,State5x
		ldi		CurrentState1,State51
		rjmp	ExitChange
ROp3:	ldi		CurrentState0,State40
		ldi		CurrentStateX,State4x
		ldi		CurrentState1,State41
		rjmp	ExitChange
	;---    V
ROp4:	ldi		CurrentState0,State30
		ldi		CurrentStateX,State3x
		ldi		CurrentState1,State31
		rjmp	ExitChange
ROp5:	ldi		CurrentState0,State20
		ldi		CurrentStateX,State2x
		ldi		CurrentState1,State21
		rjmp	ExitChange
;------------------------------------------------
;---    -------------------
NeedChangeSpeed:
		cp		Speed,NewSpeed
		brlo	CurrentSpeedLower
		breq	CurrentSpeedEqual
CurrentSpeedBigger:  ;---   
		dec 	Speed	;  
		mov		UartData,Speed
		sbic	UCSRA,UDRE		;     -   ()
		out		UDR,UartData
		ret
CurrentSpeedLower:   ;---   
		inc		Speed	;  
		mov		UartData,Speed
		sbic	UCSRA,UDRE		;     -   ()
		out		UDR,UartData
		ret
CurrentSpeedEqual:   ;---    
		cbr		Flags,1<<SpeedFlag ;     
		ret
;------------------------------------------------
;---    UART -------------------
RecieveData:
		in		UartData,UDR			;  
		tst		UartData
		breq	ExitReadData
		sbrc	Flags,NeedReadSpeed		;    ?
		rjmp	SetNewSpeed
		sbrc	Flags,NeedReadShim		;      ?
		rjmp	SetNewShim
		sbrc	Flags,NeedReadAcceleration	;    ?
		rjmp	SetNewAcceleration
	;---  
		cpi		UartData, Command1		;   1?
		breq	SetReadSpeedFlag
		cpi		UartData, Command2		;   2?
		breq	SetReadShimFlag
		cpi		UartData, Command3		;   3?
		breq	SetReadAccelerationFlag
		cpi		UartData, Command4		;   4?
		breq	SetStartFlag
		cpi		UartData, Command5		;   5?
		breq	ClearStartFlag
		cpi		UartData, Command6		;   6?
		breq	ClearReverseFlag
		cpi		UartData, Command7		;   7?
		breq	SetReverseFlag
ExitReadData:
		ldi		UartData,0xFF			;  
		out		UDR,UartData
        ret
	;---  
SetReadSpeedFlag:
		sbr		Flags,1<<NeedReadSpeed
		ldi		UartData,Wait			;  
		out		UDR,UartData
		ret
SetReadShimFlag:
		sbr		Flags,1<<NeedReadShim
		ldi		UartData,Wait			;  
		out		UDR,UartData
		ret
SetReadAccelerationFlag:
		sbr		Flags,1<<NeedReadAcceleration
		ldi		UartData,Wait			;  
		out		UDR,UartData
		ret
SetStartFlag:
		sbr		Flags,1<<StartFlag
		ldi		UartData,Good
		out		UDR,UartData
		ret
ClearStartFlag:
		cbr		Flags,1<<StartFlag
		ldi		UartData,Good
		out		UDR,UartData
		ret
SetReverseFlag:
		sbr		Flags,1<<ReverseFlag
		ldi		UartData,Good
		out		UDR,UartData
		ret
ClearReverseFlag:
		cbr		Flags,1<<ReverseFlag
		ldi		UartData,Good
		out		UDR,UartData
		ret
	;---  
SetNewSpeed:
		mov		NewSpeed,UartData
		cbr		Flags,1<<NeedReadSpeed
		ldi		UartData,Good
		out		UDR,UartData
		sbr		Flags,1<<SpeedFlag
		ret
SetNewShim:
		cbr		Flags,1<<NeedReadShim
		cpi		UartData,MaxShim ;  UartData >= MaxShim
		brsh	ErrorSet
		cpi		UartData,MinShim ;  UartData < MinShim
		brlo	ErrorSet
		out		OCR0A,UartData
		ldi		UartData,Good
		out		UDR,UartData		
		ret
ErrorSet:
		ldi		UartData,Error
		out		UDR,UartData
		ret
SetNewAcceleration:
		mov		Acceleration,UartData
		cbr		Flags,1<<NeedReadAcceleration
		ldi		UartData,Good
		out		UDR,UartData
		ret
